local OresMoney = CreateFrame("Frame")
OresMoney:RegisterEvent("ITEM_PUSH")

Auctionator.API.InternalVerifyID("Hywolf")
local prixTotalOr, prixMonelite, prixFoudrargent, prixPlatine, prixOsmenite, prixRivebulbe, prixMousseEtoilee, prixMacheDAkunda, prixBiseDHiver, prixPollenDeSirene, prixAncoracee, prixBrinDeMer, prixZinAnthide = 0
local prixTotalMonelite, prixTotalFoudrargent, prixTotalPlatine, prixTotalOsmenite, prixTotalRivebulbe, prixTotalMousseEtoilee, prixTotalMacheDAkunda, prixTotalBiseDHiver, prixTotalPollenDeSirene, prixTotalAncoracee, prixTotalBrinDeMer, prixTotalZinAnthide = 0
local countMonelite, countFoudrargent, countPlatine, countOsmenite, countRivebulbe, countMousseEtoilee, countMacheDAkunda, countBiseDHiver, countPollenDeSirene, countAncoracee, countBrinDeMer, countZinAnthide = 0
local prixPotionSoinsAbyssale = 0
local prefix = "|cFFF0CB1E[Ohm]|r"

local UIOHMoney

-- Message d'accueil
print(prefix, "Type |cFFF0CB1E/ohm |rto show your ore/herb value")
print(prefix, "Type |cFFF0CB1E/ohm ah |rto show AH ore/herb price")


-- Arrondi
local function round(n)
    return math.floor(n + 0.5)
end

-- Calcul la valeur des minerais possédés
local function moneyCount()
    -- On compte les minerais
    countMonelite = GetItemCount(152512)
    countFoudrargent = GetItemCount(152579)
    countPlatine = GetItemCount(152513)
    countOsmenite = GetItemCount(168185)

    countRivebulbe = GetItemCount(152505)
    countMousseEtoilee = GetItemCount(152506)
    countMacheDAkunda = GetItemCount(152507)
    countBiseDHiver = GetItemCount(152508)
    countPollenDeSirene = GetItemCount(152509)
    countAncoracee = GetItemCount(152510)
    countBrinDeMer = GetItemCount(152511)
    countZinAnthide = GetItemCount(168487)
    -- On récupère les prix unités depuis Auctionator
    prixMonelite = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 152512) / 10000
    prixFoudrargent = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 152579) / 10000
    prixPlatine = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 152513) / 10000
    prixOsmenite = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 168185) / 10000

    prixRivebulbe = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 152505) / 10000
    prixMousseEtoilee = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 152506) / 10000
    prixMacheDAkunda = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 152507) / 10000
    prixBiseDHiver = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 152508) / 10000
    prixPollenDeSirene = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 152509) / 10000
    prixAncoracee = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 152510) / 10000
    prixBrinDeMer = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 152511) / 10000
    prixZinAnthide = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 168487) / 10000
    -- On calcul le prix de chaque lot de minerai
    prixTotalMonelite = countMonelite * prixMonelite
    prixTotalFoudrargent = countFoudrargent * prixFoudrargent
    prixTotalPlatine = countPlatine * prixPlatine
    prixTotalOsmenite = countOsmenite * prixOsmenite

    prixTotalRivebulbe = countRivebulbe * prixRivebulbe
    prixTotalMousseEtoilee = countMousseEtoilee * prixMousseEtoilee
    prixTotalMacheDAkunda = countMacheDAkunda * prixMacheDAkunda
    prixTotalBiseDHiver = countBiseDHiver * prixBiseDHiver
    prixTotalPollenDeSirene = countPollenDeSirene * prixPollenDeSirene
    prixTotalAncoracee = countAncoracee * prixAncoracee
    prixTotalBrinDeMer = countBrinDeMer * prixBrinDeMer
    prixTotalZinAnthide = countZinAnthide * prixZinAnthide
    -- On calcul le prix total
    local prixTotal = prixTotalMonelite + prixTotalFoudrargent + prixTotalPlatine + prixTotalOsmenite + prixTotalRivebulbe + prixTotalMousseEtoilee + prixTotalMacheDAkunda + prixTotalBiseDHiver + prixTotalPollenDeSirene + prixTotalAncoracee + prixTotalBrinDeMer + prixTotalZinAnthide
    prixTotalOr = prixTotal
    -- On affiche le prix dans le tchat
    -- print(prefix, "Ore/herb value: |cFFF0CB1E", GetCoinTextureString(prixTotalOr*10000))
end

local function refreshOHMoney()
    moneyCount()
    -- Si UI ouvert
    if UIOHMoney ~= nil then
        UIOHMoney.panelRight:SetText('<html><body>'..
        '<p>'..GetCoinTextureString(prixTotalMonelite*10000, 10)..'</p>'..
        '<p>'..GetCoinTextureString(prixTotalFoudrargent*10000, 10)..'</p>'..
        '<p>'..GetCoinTextureString(prixTotalPlatine*10000, 10)..'</p>'..
        '<p>'..GetCoinTextureString(prixTotalOsmenite*10000, 10)..'</p>'..
        '<p><br /></p>'..
        '<p>'..GetCoinTextureString(prixTotalRivebulbe*10000, 10)..'</p>'..
        '<p>'..GetCoinTextureString(prixTotalMousseEtoilee*10000, 10)..'</p>'..
        '<p>'..GetCoinTextureString(prixTotalMacheDAkunda*10000, 10)..'</p>'..
        '<p>'..GetCoinTextureString(prixTotalBiseDHiver*10000, 10)..'</p>'..
        '<p>'..GetCoinTextureString(prixTotalPollenDeSirene*10000, 10)..'</p>'..
        '<p>'..GetCoinTextureString(prixTotalAncoracee*10000, 10)..'</p>'..
        '<p>'..GetCoinTextureString(prixTotalBrinDeMer*10000, 10)..'</p>'..
        '<p>'..GetCoinTextureString(prixTotalZinAnthide*10000, 10)..'</p>'..
        '<p><br /></p>'..
        '<p>'..GetCoinTextureString(prixTotalOr*10000, 10)..'</p>'..
        '</body></html>');
    
        
    end
end

local function cmdAhPrice()
    print(prefix, "AH ORES price unit:")
    print(" Monelite ore: |cFFF0CB1E", GetCoinTextureString(prixMonelite*10000))
    print("Storm silver ore: |cFFF0CB1E", GetCoinTextureString(prixFoudrargent*10000))
    print("Platinum ore: |cFFF0CB1E", GetCoinTextureString(prixPlatine*10000))
    print("Osmenite ore: |cFFF0CB1E", GetCoinTextureString(prixOsmenite*10000))
    print(prefix, "AH HERBS price unit:")
    print("Riverbud: |cFFF0CB1E", GetCoinTextureString(prixRivebulbe*10000))
    print("Star moss: |cFFF0CB1E", GetCoinTextureString(prixMousseEtoilee*10000))
    print("Akunda's bite: |cFFF0CB1E", GetCoinTextureString(prixMacheDAkunda*10000))
    print("Winter's kiss: |cFFF0CB1E", GetCoinTextureString(prixBiseDHiver*10000))
    print("Siren's pollen: |cFFF0CB1E", GetCoinTextureString(prixPollenDeSirene*10000))
    print("Anchor weed: |cFFF0CB1E", GetCoinTextureString(prixAncoracee*10000))
    print("Sea stalk: |cFFF0CB1E", GetCoinTextureString(prixBrinDeMer*10000))
    print("Zin'anthid: |cFFF0CB1E", GetCoinTextureString(prixZinAnthide*10000))
end

local function craftRentability(n)
    local diff, pourc = 0
    -- Prix unité potion
    prixObj = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 169451) / 10000
    -- Rentablilité du craft
    diff = prixObj - prixZinAnthide*2
    pourc = round((prixObj / (prixZinAnthide*2)) * 100 - 100)
    print(prefix, "Rentabilité 'Potion de soins Abyssale': |cFF00BB22", diff.."g ("..pourc.."%)")


    -- Prix unité potion
    prixObj = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 168500) / 10000
    -- Rentablilité du craft
    diff = prixObj - (prixZinAnthide*8 + prixMousseEtoilee*3)
    pourc = round((prixObj / (prixZinAnthide*8 + prixMousseEtoilee*3)) * 100 - 100)
    print(prefix, "Rentabilité 'Potion force': |cFF00BB22", diff.."g ("..pourc.."%)")

    -- Prix unité potion
    prixObj = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 169299) / 10000
    -- Rentablilité du craft
    diff = prixObj - (prixZinAnthide*6)
    pourc = round((prixObj / (prixZinAnthide*6)) * 100 - 100)
    print(prefix, "Rentabilité 'Potion de fureur débridée': |cFF00BB22", diff.."g ("..pourc.."%)")

    -- Prix unité potion
    prixObj = Auctionator.API.v1.GetAuctionPriceByItemID("Hywolf", 159826) / 10000
    -- Rentablilité du craft
    diff = prixObj - (prixMonelite*4)
    pourc = round((prixObj / (prixMonelite*4)) * 100 - 100)
    print(prefix, "Rentabilité 'Passe-partout en monélite': |cFF00BB22", diff.."g ("..pourc.."%)")
end

-- Lorsque qu'un item est ramassé...
OresMoney:SetScript("OnEvent",
function(self, event, ...)    
    local arg1, arg2 = ...    

    -- On detecte si un minerai. Si oui on lance
    if arg2 == 2037638 or arg2 == 2037640 or arg2 == 2037639 or arg2 == 2543233 or arg2 == 1785788 or arg2 == 1794517 or arg2 == 1785410 or arg2 == 1784025 or arg2 == 1956510 or arg2 == 1914118 or arg2 == 1956511 or arg2 == 2563958 then
        refreshOHMoney();
    end
    
end)

local function openUIAHPrice()
    local UIAHPrice = CreateFrame("Frame", "OHM_UIAHPrice", UIParent, "BasicFrameTemplateWithInset");
    UIAHPrice:SetSize(250, 270);
    UIAHPrice:SetMovable(true)
    UIAHPrice:EnableMouse(true)
    UIAHPrice:RegisterForDrag("LeftButton")
    UIAHPrice:SetScript("OnDragStart", UIAHPrice.StartMoving)
    UIAHPrice:SetScript("OnDragStop", UIAHPrice.StopMovingOrSizing)
    UIAHPrice:SetPoint("CENTER"); -- Doesn't need to be ("CENTER", UIParent, "CENTER")

    UIAHPrice.title = UIAHPrice:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
    UIAHPrice.title:SetPoint("LEFT", UIAHPrice.TitleBg, "LEFT", 5, 0);
    UIAHPrice.title:SetText(prefix.." AH price / unit");

    -- Panel Left:
    UIAHPrice.panelLeft = CreateFrame("SimpleHTML", nil, UIAHPrice);
    UIAHPrice.panelLeft:SetFont("Fonts\\FRIZQT__.ttf", 12, "OUTLINE");
    UIAHPrice.panelLeft:SetPoint("LEFT", UIAHPrice, "LEFT", 15, 0);
    UIAHPrice.panelLeft:SetSize(125, 180);
    UIAHPrice.panelLeft:SetText('<html><body>'..
    '<p>Monelite Ore</p>'..
    '<p>Storm silver Ore</p>'..
    '<p>Platinum Ore</p>'..
    '<p>Osmenite Ore</p>'..
    '<p><br /></p>'..
    '<p>Riverbud</p>'..
    '<p>Star moss</p>'..
    '<p>Akunda\'s bite</p>'..
    '<p>Winter\'s kiss</p>'..
    '<p>Siren\'s pollen</p>'..
    '<p>Anchor weed</p>'..
    '<p>Sea stalk</p>'..
    '<p>Zin\'anthid</p>'..
    '</body></html>');

    -- Panel Right:
    UIAHPrice.panelRight = CreateFrame("SimpleHTML", nil, UIAHPrice);
    UIAHPrice.panelRight:SetFont("Fonts\\FRIZQT__.ttf", 12, "OUTLINE");
    UIAHPrice.panelRight:SetPoint("LEFT", UIAHPrice, "LEFT", 120, 0);
    UIAHPrice.panelRight:SetSize(140, 180);
    UIAHPrice.panelRight:SetText('<html><body>'..
    '<p>'..GetCoinTextureString(prixMonelite*10000, 10)..'</p>'..
    '<p>'..GetCoinTextureString(prixFoudrargent*10000, 10)..'</p>'..
    '<p>'..GetCoinTextureString(prixPlatine*10000, 10)..'</p>'..
    '<p>'..GetCoinTextureString(prixOsmenite*10000, 10)..'</p>'..
    '<p><br /></p>'..
    '<p>'..GetCoinTextureString(prixRivebulbe*10000, 10)..'</p>'..
    '<p>'..GetCoinTextureString(prixMousseEtoilee*10000, 10)..'</p>'..
    '<p>'..GetCoinTextureString(prixMacheDAkunda*10000, 10)..'</p>'..
    '<p>'..GetCoinTextureString(prixBiseDHiver*10000, 10)..'</p>'..
    '<p>'..GetCoinTextureString(prixPollenDeSirene*10000, 10)..'</p>'..
    '<p>'..GetCoinTextureString(prixAncoracee*10000, 10)..'</p>'..
    '<p>'..GetCoinTextureString(prixBrinDeMer*10000, 10)..'</p>'..
    '<p>'..GetCoinTextureString(prixZinAnthide*10000, 10)..'</p>'..
    '</body></html>');
end

local function openUIOHMoney()
    UIOHMoney = CreateFrame("Frame", "OHM_UIOHMoney", UIParent, "BasicFrameTemplateWithInset");
    UIOHMoney:SetSize(250, 270);
    UIOHMoney:SetMovable(true)
    UIOHMoney:EnableMouse(true)
    UIOHMoney:RegisterForDrag("LeftButton")
    UIOHMoney:SetScript("OnDragStart", UIOHMoney.StartMoving)
    UIOHMoney:SetScript("OnDragStop", UIOHMoney.StopMovingOrSizing)
    UIOHMoney:SetPoint("CENTER"); -- Doesn't need to be ("CENTER", UIParent, "CENTER")

    UIOHMoney.title = UIOHMoney:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
    UIOHMoney.title:SetPoint("LEFT", UIOHMoney.TitleBg, "LEFT", 5, 0);
    UIOHMoney.title:SetText(prefix.." Value of your ores/herbs");

    -- Panel Left:
    UIOHMoney.panelLeft = CreateFrame("SimpleHTML", nil, UIOHMoney);
    UIOHMoney.panelLeft:SetFont("Fonts\\FRIZQT__.ttf", 12, "OUTLINE");
    UIOHMoney.panelLeft:SetPoint("LEFT", UIOHMoney, "LEFT", 15, 0);
    UIOHMoney.panelLeft:SetSize(125, 180);
    UIOHMoney.panelLeft:SetText('<html><body>'..
    '<p>Monelite Ore</p>'..
    '<p>Storm silver Ore</p>'..
    '<p>Platinum Ore</p>'..
    '<p>Osmenite Ore</p>'..
    '<p><br /></p>'..
    '<p>Riverbud</p>'..
    '<p>Star moss</p>'..
    '<p>Akunda\'s bite</p>'..
    '<p>Winter\'s kiss</p>'..
    '<p>Siren\'s pollen</p>'..
    '<p>Anchor weed</p>'..
    '<p>Sea stalk</p>'..
    '<p>Zin\'anthid</p>'..
    '<p><br /></p>'..
    '<p>TOTAL VALUE</p>'..
    '</body></html>');

    -- Panel Right:
    UIOHMoney.panelRight = CreateFrame("SimpleHTML", nil, UIOHMoney);
    UIOHMoney.panelRight:SetFont("Fonts\\FRIZQT__.ttf", 12, "OUTLINE");
    UIOHMoney.panelRight:SetPoint("LEFT", UIOHMoney, "LEFT", 120, 0);
    UIOHMoney.panelRight:SetSize(140, 180);
    refreshOHMoney();
end


-- Commande /ohm pour lancer la fonction
SLASH_ohm1 = "/ohm"
SlashCmdList ["ohm"] = function ( msg )
    if msg == "" then
        moneyCount()
        openUIOHMoney()
    elseif msg == "1" then
        moneyCount()
        craftRentability(1)    
    elseif msg == "ah" then
        moneyCount()
        -- cmdAhPrice()
        openUIAHPrice()
    else
    end
end